import Vue from 'vue'

import Cookies from 'js-cookie'

import Element from 'element-ui'
import './assets/styles/element-variables.scss'

import '@/assets/styles/index.scss' // global css
import '@/assets/styles/bonus.scss' // bonus css
import App from './App'
import store from './store'
import router from './router'
import directive from './directive' // directive
import plugins from './plugins' // plugins
import { download, derive } from '@/utils/request'

import './assets/icons' // icon
import './permission' // permission control

import VbaiduMap from 'vue-baidu-map'
import { getDicts } from '@/api/system/dict/data'
import { getConfigKey } from '@/api/system/config'
import {
  parseTime,
  resetForm,
  addDateRange,
  selectDictLabel,
  selectDictLabels,
  handleTree,
  indexContinuous,
} from '@/utils/bonus'
// 分页组件
import Pagination from '@/components/Pagination'
// 自定义表格工具组件
import RightToolbar from '@/components/RightToolbar'
// 富文本组件
import Editor from '@/components/Editor'
// 文件上传组件
import FileUpload from '@/components/FileUpload'
// 图片上传组件
import ImageUpload from '@/components/ImageUpload'
// 图片预览组件
import ImagePreview from '@/components/ImagePreview'
// 字典标签组件
import DictTag from '@/components/DictTag'
// 头部标签组件
import VueMeta from 'vue-meta'
// 字典数据组件
import DictData from '@/components/DictData'

import scroll from 'vue-seamless-scroll'

import preventReClick from '@/utils/preventReClick'

// 全局方法挂载
Vue.prototype.getDicts = getDicts
Vue.prototype.getConfigKey = getConfigKey
Vue.prototype.parseTime = parseTime
Vue.prototype.resetForm = resetForm
Vue.prototype.addDateRange = addDateRange
Vue.prototype.selectDictLabel = selectDictLabel
Vue.prototype.selectDictLabels = selectDictLabels
Vue.prototype.download = download
Vue.prototype.derive = derive
Vue.prototype.handleTree = handleTree
Vue.prototype.indexContinuous = indexContinuous

// 全局组件挂载
Vue.component('DictTag', DictTag)
Vue.component('Pagination', Pagination)
Vue.component('RightToolbar', RightToolbar)
Vue.component('Editor', Editor)
Vue.component('FileUpload', FileUpload)
Vue.component('ImageUpload', ImageUpload)
Vue.component('ImagePreview', ImagePreview)

Vue.use(directive)
Vue.use(plugins)
Vue.use(VueMeta)

DictData.install()

Vue.use(scroll)
Vue.use(preventReClick)

Vue.directive('no-whitespace', {
  bind(el, binding, vnode) {
    const input = el.querySelector('input') || el.querySelector('textarea')
    if (!input) return

    const handleInput = event => {
      const value = event.target.value.trim()
      if (value === '' || value.replace(/\s/g, '') === '') {
        //设置event.target.value的值为undefined，为了触发v-model的更新
        input.removeEventListener('input', handleInput)
        event.target.value = ''
        input.dispatchEvent(new Event('input'))
        input.addEventListener('input', handleInput)
      }
    }
    input.addEventListener('input', handleInput)
    input.addEventListener('blur', handleInput)
  },
})

/**
 * If you don't want to use mock-server
 * you want to use MockJs for mock api
 * you can execute: mockXHR()
 *
 * Currently MockJs will be used in the production environment,
 * please remove it before going online! ! !
 */

Vue.use(Element, {
  size: Cookies.get('size') || 'medium', // set element-ui default size
})

// 全局配置 v-baidu-map 的 API 密钥
Vue.use(VbaiduMap, {
  ak: 'PM43nB8eDNTBrXkQwGrTQFcmOni3Z9nO',
})

Vue.config.productionTip = false

new Vue({
  el: '#app',
  router,
  store,
  render: h => h(App),
})
